#ifndef CONFIG_H
#define CONFIG_H

#define MAX_PLAYERS 6

#define MAX_STRIEL_OD_HRACA 6    //maximalny pocet striel, ktore moze mat hrac sucesne vystrelenych

#define FGUI_NAME "./fgui"
#define FTOPLAYER_NAME "./ftoplayer%d"
#define FFROMPLAYER_NAME "./ffromplayer%d"

//zaciatok sprav pre hraca
#define FP_STAV       0  //toto vidis
#define FP_TAHAJ      1  //povedz svoj tah
#define FP_VYSTRELIT_ 2  //vystrelit?
#define FP_KONIEC     3  //koniec


//moznosti pohybu hraca
#define TP_TAH_NIC        0
#define TP_TAH_DOPREDU    1
#define TP_TAH_DOZADU     2
#define TP_TAH_DOLAVA     3
#define TP_TAH_DOPRAVA    4
#define TP_TAH_POCET      5

#define TP_VYSTREL_NIC        0  //nie, nestrielaj
#define TP_VYSTREL_STRELIT    1  //ano, vystrel
#define TP_VYSTREL_POCET      2


#define HOME_POLOMER 4     //rozmer strany domceka je HOME_POLOMER*2+1 

#define STAV_POLOMER 9      //kolko policok vidi tank okolo svojho zakladneho bodu na kazdu stranu?
#define STAV_STRANA  19     //strana stvorca, ktory vidi tank

#define MAX_BOARD_SIZE 160
#define BOARD_BORDER 8

#define TANK_EN 4000               //energia, ktoru ma tank na zaciatku
#define TANK_EN_DOPLNANIE 4        //kolko energie sa doplna v domceku

#define TANK_HP 10000              //stit, ktory ma tank na zaciatku
#define TANK_HP_DOPLNANIE 7        //kolko stitu sa doplna v domceku

#define TANK_ENHP_ZASAH 2000       //kolko energie/stitu uberie jeden zasah

#define TANK_CAS_RESET 1           //od zabitia do objavenia doma
#define TANK_CAS_NIC   1           //nic nerobenie
#define TANK_CAS_DOPREDU 3         //presun o jedno policko dopredu
#define TANK_CAS_DOZADU  5         //presun o jedno policko dozadu
#define TANK_CAS_OTOC  2           //otocenie o 45 stupnov

#define TANK_CAS_BAGER 2           //zbagrovanie jedneho dielika zeme
#define TANK_CAS_VYSTREL 3         //vystrel trva takuto dobu, rychlejsie sa strielat neda

//spotrebovana energia na:
#define TANK_EN_NIC   1           //nic nerobenie
#define TANK_EN_DODPREDU  6       //presun o jedno policko dopredu
#define TANK_EN_DOZADU  10        //presun o jedno policko dozadu
#define TANK_EN_OTOC  4           //otocenie o jeden stupen
#define TANK_EN_BAGER 10          //zbagrovanie jedneho dielika zeme
#define TANK_EN_VYSTREL 40        //vystrel


//vsetky typy objektov, ake existuju
typedef enum {
	objNic,
	objZem,
	objStena,
	objDom,
	objStrela,
	objTank,
	objPocet,   //pocet typov objektov
	objKoniec   //indikuje, ze nenasleduju ziadne dalsie objekty
} TypyObjektov;


//fifo gui
#define FG_END_TURN -1
#define FG_END_GAME -2

#define POINTS_GROUND_DIVIDER 10   //body za zaminu dostavaju za vzdialenost od domceka delenu touto konstantou
#define POINTS_KILL          2500
#define POINTS_DEAD         -1000

#endif //CONFIG_H
