#ifndef TYPES_H
#define TYPES_H

#include "config.h"

//stringu popisujuce objekty
extern char typyNazvy[objPocet][10];
//jednoznakove popisy ojektov - pre zobrazovanie
extern char typyKod[objPocet];

//vsetkych osem smerov (SV=severovychod)
typedef enum {
	smerS,
	smerSV,
	smerV,
	smerJV,
	smerJ,
	smerJZ,
	smerZ,
	smerSZ,
	smerPocet
} Smery;

typedef struct {
	int x,y;
} PointStruct;

//lowlevel realizacia smerov
extern PointStruct smer[smerPocet];

extern char strelaKody[smerPocet];

#define TANK_ROZMER 5

extern PointStruct tankOffset;  //posunutie zakladneho bodu oproti laveho horneho rohu tankTvary
extern bool tankTvary[smerPocet][TANK_ROZMER][TANK_ROZMER]; //tvary tanku pri jednotlivych natoceniach

extern int tankCasy[TP_TAH_POCET];  //kolko trvaju jednotlive pohyby
extern int tankEn[TP_TAH_POCET];    //kolko energie beru jednotlive pohyby

typedef enum {    //spravy, ktore posiea server hracovi
	fpcPocet
} FifoPlayerCommand;

#endif //TYPES_H
