unit player;
interface
uses types;

procedure init;
procedure done;
procedure novyStav( const stav:TStav);
function vratTah:integer;
function mamStrelit:boolean;

//hlaska nesmie obsahovat obsahovat znaky noveho riadku
function vratHlasku:string;

implementation
uses linux, sysutils,
     config;
     
{ nas kod }
var tahh :integer;
    strelit :boolean;
    mydir :integer; // moj smer
    domy :array[1..6] of TPoint;
    ndomy :integer;
type TCasy=array[0..5] of integer;
const ysmer :array[0..7] of integer=(0,1,1,1,0,-1,-1,-1);
      xsmer :array[0..7] of integer=(1,1,0,-1,-1,-1,0,1);
      xotocs :array[0..3,1..4] of integer=((2,2,1,-1),(-1,-2,-2,2),(-1,-2,-2,1),(1,2,2,-2));
      yotocs :array[0..3,1..4] of integer=((1,2,2,-2),(2,2,1,-1),(-2,-2,-1,2),(-2,-2,-1,1));
      xotocs2 :array[0..3,1..5] of integer=((0,1,1,0,-1),(1,2,2,-2,-1),(-1,-1,0,0,1),(-1,-2,-2,2,1));
      yotocs2 :array[0..3,1..5] of integer=((-2,-2,-1,2,1),(1,1,0,0,-1),(1,2,2,-2,-1),(-1,-1,0,0,1));
      xdopredu :array[0..7,1..3] of integer=((2,3,2),(2,3,3),(1,0,1),(-2,-3,-3),(-2,-3,-2),(-2,-3,-3),(1,0,1),(2,3,3));
      ydopredu :array[0..7,1..3] of integer=((1,0,-1),(3,3,2),(2,3,2),(3,3,2),(-1,0,1),(-3,-3,-2),(-2,-3,-2),(-3,-3,-2));
      xdozadu :array[0..7,1..3] of integer=((-3,-3,-3),(-2,-2,-3),(1,0,-1),(2,2,3),(3,3,3),(2,2,3),(1,0,-1),(-2,-2,-3));
      ydozadu :array[0..7,1..3] of integer=((-1,0,1),(-3,-2,-2),(-3,-3,-3),(-3,-2,-2),(-1,0,1),(3,2,2),(3,3,3),(3,2,2));
      kamx :integer=0;
      kamy :integer=0;

function cislosmeru(x,y :integer) :integer;
begin
    if (y>0) then 
	if x=0 then cislosmeru:=0
	       else if (x>0) then cislosmeru:=1
	    		     else cislosmeru:=7
    else if (y<0) then
	if x=0 then cislosmeru:=4
	       else if (x>0) then cislosmeru:=3
	    		     else cislosmeru:=5
    else if x>0 then cislosmeru:=2
		else if x<0 then cislosmeru:=6
			    else cislosmeru:=500;
end;

function rozdsmerov(a,b :integer;var orvpr :boolean) :integer;
var pom :integer;
begin
    if (a<b) then begin
	if (b-a<7+a-b) then begin
	    pom:=b-a;
	    orvpr:=true;
	end else begin
	    pom:=7+a-b;
	    orvpr:=false; 
	end;
    end else begin
	if (a-b<7+b-a) then begin
	    pom:=a-b;
	    orvpr:=false;
	end else begin
	    pom:=7+b-a;
	    orvpr:=true;
	end;
    end;
    rozdsmerov:=pom;
    if not ((pom>=0) and (pom<=4)) then rozdsmerov:=20;
end;

procedure dajcasy(stav :TStav; dir :integer; var casy :TCasy);
var i :integer;
begin
 { vypocitame casy operacii a spotrebu energie }
 with stav do begin
	for i:=0 to 4 do casy[i]:=0;
	{ otocenie doprava }
	casy[TP_TAH_DOPRAVA]:=TANK_CAS_OTOC;
	if (dir mod 2=0) then begin	
	    for i:=1 to 4 do 
		if vidim[STAV_POLOMER+1+xotocs[dir div 2,i],STAV_POLOMER+1+yotocs[dir div 2,i]]='X' then inc(casy[TP_TAH_DOPRAVA],TANK_CAS_BAGER);
	end else begin
	    for i:=1 to 5 do 
		if vidim[STAV_POLOMER+1+xotocs[dir div 2,i],STAV_POLOMER+1+yotocs[dir div 2,i]]='X' then inc(casy[TP_TAH_DOPRAVA],TANK_CAS_BAGER);
	end;
	{ otocenie dolava }
	casy[TP_TAH_DOLAVA]:=TANK_CAS_OTOC;
	if (dir mod 2=0) then begin	
	    for i:=1 to 4 do 
		if vidim[STAV_POLOMER+1+xotocs[((5+dir) mod 8) div 2,i],STAV_POLOMER+1+yotocs[((5+dir) mod 7) div 2,i]]='X' then inc(casy[TP_TAH_DOLAVA],TANK_CAS_BAGER);
	end else begin
	    for i:=1 to 5 do 
		if vidim[STAV_POLOMER+1+xotocs[((5+dir) mod 8) div 2,i],STAV_POLOMER+1+yotocs[((5+dir) mod 7) div 2,i]]='X' then inc(casy[TP_TAH_DOLAVA],TANK_CAS_BAGER);
	end;
	{ pohyb dopredu }
	casy[TP_TAH_DOPREDU]:=-1;
	if vidim[STAV_POLOMER+1-3*xsmer[dir],STAV_POLOMER+1+3*ysmer[dir]]<>'#' then begin
	    for i:=1 to 3 do 
		if vidim[STAV_POLOMER+1+xdopredu[dir,i],STAV_POLOMER+1+ydopredu[dir,i]]='X' then inc(casy[TP_TAH_DOPREDU],TANK_CAS_BAGER);
	    inc(casy[TP_TAH_DOPREDU],TANK_CAS_DOPREDU);
	end;
	{ pohyb dozadu }
	casy[TP_TAH_DOZADU]:=TANK_CAS_DOZADU;
	for i:=1 to 3 do { zistime, ci mozme ist dozadu }
	    if vidim[STAV_POLOMER+1+xdozadu[dir,i],STAV_POLOMER+1+ydozadu[dir,i]]='#' then begin
		casy[TP_TAH_DOZADU]:=-1;
		break;
	end;
	if casy[TP_TAH_DOZADU]<>-1 then begin { ak mozme ist dozadu }
	    for i:=1 to 3 do 
		if vidim[STAV_POLOMER+1+xdozadu[dir,i],STAV_POLOMER+1+ydozadu[dir,i]]='X' then inc(casy[TP_TAH_DOZADU],TANK_CAS_BAGER);
	end;
    end;
end;

function chodna(stav :TStav; dx,dy :integer) :integer;
var na1,na2 :integer;
    orvpr1,orvpr2 :boolean;
begin
  with stav do begin
    if (abs(dx)=abs(dy)) then begin
		na1:=cislosmeru(-dx,dy);
		na2:=na1;
	    end else begin
		if (abs(dx)>abs(dy)) then na1:=cislosmeru(-dx,0)
		else na1:=cislosmeru(0,dy);
		if (dx<>0) and (dy<>0) then na2:=cislosmeru(-dx,dy)
		else na2:=na1;
	    end;
	    { ak sme nasmerovany domov, tak len ideme }
	    if (ja.dir=na1) or (ja.dir=na2) then chodna:=TP_TAH_DOPREDU
	    else begin
		{ inak sa otocime }
		na1:=rozdsmerov(ja.dir,na1,orvpr1);
		na2:=rozdsmerov(ja.dir,na2,orvpr2);
		if (na1<na2) then begin
		    if orvpr1 then chodna:=TP_TAH_DOPRAVA
		    else chodna:=TP_TAH_DOLAVA;
		end else begin
		    if (orvpr2) then chodna:=TP_TAH_DOPRAVA
		    else chodna:=TP_TAH_DOLAVA;
		end;
	    end;
    end;
end;

{ koniec nasho kodu }

var lastNow : TDateTime;
    tah : integer;
    strielat : boolean;

function now_msec:double;
var hour, min, sec, msec : word;
begin
  getTime(hour, min, sec, msec);
  now_msec:= date + (hour*60*60 + min*60 + sec + msec/100.0)/(24*60*60);
end;

procedure textOut(x,y:word; const s:string);  //z dokumentacie
var p,m,i: word;
begin
{  p:=(x-1)+(y-1)*screenwidth;
  m:=length(s);
  if m+x>=screenwidth then
    m:=screenwidth-x;
  for i:=1 to m do
    videobuf^[p+i-1]:=ord(s[i])+($07 shr 8);}
end;

procedure init;
begin
//  InitVideo;
//  InitKeyboard;

  lastNow:=now_msec;

  tah:=TP_TAH_NIC;
  { nas kod }
  strelit:=false;
  randomize;
  kamx:=0;
  kamy:=0;
  ndomy:=0;
  mydir:=0;
  { koniec nasho kodu }
end;

procedure done;
begin
//  DoneVideo;
 // DoneKeyboard;
end;

procedure writer(x :integer; a :string);
begin
{ setcursorpos(x,5+STAV_STRANA+ndomy);
 write(a);
 setcursorpos(x,6+STAV_STRANA+ndomy);
 write(a);
 setcursorpos(x,5+STAV_STRANA+ndomy);}
end;

procedure novyStav( const stav:TStav);
var pis_y, i, j,px,py,ccas : integer;
    na1,na2,pomdir,casvpravo,casvlavo :integer;
    orvpr1,orvpr2 :boolean;
    pcasy,casy :TCasy;
    stre :array[1..STAV_STRANA,1..STAV_STRANA] of integer;
    strecislo :array[1..STAV_STRANA,1..STAV_STRANA] of integer;
    minhp,natank,nastrelu :integer;
    lockdopredu,lockhome,vlavo :boolean;
    mamedom,mozmestrelit :boolean;
const homein :integer=HOME_POLOMER-1;
begin
(*  with stav do begin
    SetCursorPos( 1,0 );
    writeln(' Cas ',cas:4);

    for i:=1 to STAV_STRANA do begin
      for j:=1 to STAV_STRANA do
        write(vidim[i][j]);
      writeln;
    end;

    pis_y:=1;
    for i:=1 to objekty_pocet do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      case objekty[i].typ of
        objTank   :
          with objekty[i].tank do begin
            writeln('Hrac ',number,':  poz ',poz.x:3,',',poz.y:3,'  smer ',dir,'  spi ',spi,'       ');
            SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
            writeln('         EN ',en:4,'  HP ',hp:4,'  striel ', striel,'          ');
          end;
        objStrela :
          with objekty[i].strela do
            writeln('Strela : pos ',poz.x:3,',',poz.y:3, '  smer ',dir,'  vlastnik ',number,'           ');
        objDom :
          with objekty[i].dom do
            writeln('Dom ',number,': pos ',poz.x:3,',',poz.y:3, '  vlastnik ',number,'           ');
        else
          writeln('Neosetreny objekt                                        ');
      end;
    end;
    for i:=objekty_pocet to STAV_STRANA+1 do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      writeln('                                              ');
    end;

  SetCursorPos( 1, STAV_STRANA+1);
  with ja do 
    writeln('EN ',en:4,'  HP ',hp:4, '  spi ',spi:2, '  striel ',striel:2, '                   ');
    writeln(' domov ',domov.x:3,', ',domov.y:3, ' smer ',ja.dir,' kam: [',kamx,',',kamy,']          ');
    writeln(' ndomy: ',ndomy);
//    for i:=1 to ndomy do writeln(' [',domy[i].x,',',domy[i].y,'] ',' [',domov.x,',',domov.y,']');
  end;
  *)
  { nas kod }
{  writeln('                                                      ');
  writeln('                                                      ');
  writeln('                                                      ');
  writeln('                                                      ');
  setcursorpos(1,5+STAV_STRANA+ndomy);
  writer(1,'a');}
  mydir:=stav.ja.dir;
  strelit:=false;
  lockhome:=false;
      with stav do begin
        { vypocitame casy operacii a spotrebu energie }
	dajcasy(stav,ja.dir,casy);
	FillChar(stre,sizeof(stre),0);
	{ zistime, co vidime }
	minhp:=20000;
	natank:=0;
	nastrelu:=0;
	for i:=1 to objekty_pocet do begin
	  { vidime strely? }
	  if objekty[i].typ=objStrela then with objekty[i].strela do begin
	    px:=poz.y+STAV_POLOMER+1;
	    py:=poz.x+STAV_POLOMER+1;
	    ccas:=0;
	    while (px>0) and (px<=STAV_STRANA) and (py>0) and (py<=STAV_STRANA) do begin
		dec(px,xsmer[dir]);
		inc(py,ysmer[dir]);
		if (vidim[px,py]='#') or (vidim[px,py]='X') then break;
		if vidim[px,py]=char(ja.number+ord('0')) then begin { strela na nas narazi }
		    { mozme sa jej vyhnut? }
		    { mozme ju zostrelit? }
		    if (ja.striel>0) and (px=STAV_POLOMER+1) and (py=STAV_POLOMER+1) then begin
			pomdir:=ja.dir;
			{ cas otocenia doprava }
			casvpravo:=TANK_CAS_VYSTREL;
			while pomdir<>dir do begin
			    dajcasy(stav,pomdir,pcasy);
			    inc(casvpravo,pcasy[TP_TAH_DOPRAVA]);
			    pomdir:=(pomdir+1) mod 8;
			end;
			{ cas otocenia dolava }
			casvlavo:=TANK_CAS_VYSTREL;
			while pomdir<>dir do begin
			    dajcasy(stav,pomdir,pcasy);
			    inc(casvpravo,pcasy[TP_TAH_DOLAVA]);
			    pomdir:=(pomdir+7) mod 8;
			end;
			{ stihneme? }
			if casvlavo<casvpravo then
			    if casvlavo<ccas then begin
				nastrelu:=i;
				vlavo:=true;
			end else else if casvpravo<ccas then begin
			    nastrelu:=i;
			    vlavo:=false;
			end;
		    end;
		end;
		if (stre[px,py]<>0) then if (ccas<stre[px,py]) then begin
		    stre[px,py]:=ccas;
		    strecislo[px,py]:=i;
		end else else begin
		    stre[px,py]:=ccas;
		    strecislo[px,py]:=i;
		end;
		inc(ccas);
	    end;
	  end;
//	  writer(3,'c');
	  { vidime tank? }
	  if objekty[i].typ=objTank then with objekty[i].tank do if (poz.x<>0) or (poz.y<>0) then begin
//	    writer(4,'z');
	    if en+hp<minhp then begin
		natank:=i;
		minhp:=en+hp;
	    end;
	  end;
//	  writer(5,'d');
	  { vidime dom? }
	  if objekty[i].typ=objDom then with objekty[i].dom do if (poz.x+domov.x<>0) or (poz.y+domov.y<>0) then begin
	    { vieme uz o tomto dome? }
	    mamedom:=false;
	    for j:=1 to ndomy do if (poz.x+domov.x=domy[j].x) and (poz.y+domov.y=domy[j].y) then begin
		mamedom:=true;
		break;
	    end;
	    { ak nemame, tak pridame }
	    if not mamedom then begin
		inc(ndomy);
		domy[ndomy].x:=poz.x+domov.x;
		domy[ndomy].y:=poz.y+domov.y;
	    end;
	  end;
//	  writer(6,'e');
	end;
	{ TO DO: vyp. cas na cestu domov }
	if ((ja.en<2500) or (ja.hp<3500)) and ((abs(domov.x)>homein) or (abs(domov.y)>homein)) then begin
	    { ideme domov }
	    tahh:=chodna(stav,domov.x,domov.y);
//	    writer(7,'f');
	    kamx:=0;
	    kamy:=0;
	end else begin
	    { iny pohyb }
	    { sme v domci? }
//	    writer(8,'g');
	    if (abs(domov.x)<=homein) and (abs(domov.y)<=homein) then begin { naplnime stity a energiu }
		if (ja.hp<10000) then lockhome:=true;
	    end;
	    { ak je predo mnou stena, tak sa otoc }
	    if (vidim[STAV_POLOMER+1-3*xsmer[ja.dir],STAV_POLOMER+1+3*ysmer[ja.dir]]<>'#') then begin
		{ TO DO - ak je pred nami strela, tak nejst do nej }
		if lockhome and (abs(domov.y)<=homein) and (abs(domov.x)<=homein) then begin
		    if (abs(domov.y-xsmer[ja.dir])<=homein) and (abs(domov.x+ysmer[ja.dir])<=homein) then 
			tahh:=TP_TAH_DOPREDU
		    else tahh:=TP_TAH_DOLAVA;
		end else begin
		    while (kamx=0) and (kamy=0) do begin
			if ndomy>0 then begin
			    na1:=random(ndomy)+1;
			    kamx:=-(domy[na1].x-domov.x);
			    kamy:=-(domy[na1].y+domov.y);
			    if (kamx<0) then inc(kamx,HOME_POLOMER+3)
			    else dec(kamx,HOME_POLOMER+3);
		        end;
			if (kamx=0) and (kamy=0) then begin
			    kamx:=MAX_BOARD_SIZE div 2-random(MAX_BOARD_SIZE);
			    kamy:=MAX_BOARD_SIZE div 2-random(MAX_BOARD_SIZE);
			end;
		    end;
		    tahh:=chodna(stav,kamx,kamy);
		end;
	    end else begin
		kamx:=0;
		kamy:=0;
		{ ideme na [kamx,kamy] }
		while ((kamx=0) and (kamy=0)) do begin
		    kamx:=MAX_BOARD_SIZE div 2-random(MAX_BOARD_SIZE);
		    kamy:=MAX_BOARD_SIZE div 2-random(MAX_BOARD_SIZE);
		end;
		tahh:=TP_TAH_DOLAVA;
	    end;
	end;
//	    writer(9,'h');
	    { utocime na tank? }
	    if natank<>0 then with objekty[natank].tank do begin
		mozmestrelit:=true;
//		write('ok0');
		if (abs(poz.x)<=1) then na1:=cislosmeru(0,-poz.y)
		else if (abs(poz.y)<=1) then na1:=cislosmeru(poz.x,0)
		else
		    { mame sa pohnut blizsie, alebo palit uhlopriecne? }
		    if (abs(integer(abs(poz.x))-abs(poz.y))<=1) then begin { mozme natocit a vystrelit }
			na1:=cislosmeru(poz.x,-poz.y);
//			write('ok1');
		    end else begin { treba sa pohnut inde }
			if (abs(poz.x)<=5) and (abs(poz.y)<=5) then strelit:=true;
			mozmestrelit:=false;
//			write('ok2');
			if (abs(poz.x)>abs(poz.y)) then na1:=cislosmeru(poz.x,0)
			else na1:=cislosmeru(0,-poz.y);
		    end;
		{end;}
//		write('ok3');
		na1:=rozdsmerov(ja.dir,na1,orvpr1);				
//		write('ok4+',na1,'+');
		if (na1<>0) and (na1<>20) then begin
		    if orvpr1 then tahh:=TP_TAH_DOPRAVA
		    else tahh:=TP_TAH_DOLAVA;		
		    strelit:=true;
		end else begin
//		    write('ok5');
		    if mozmestrelit then begin
			tahh:=TP_TAH_NIC;
			strelit:=true;
		    end else if vidim[STAV_POLOMER+1-3*xsmer[ja.dir],STAV_POLOMER+1+3*ysmer[ja.dir]]<>'#' then
			tahh:=TP_TAH_DOPREDU
		    else tahh:=TP_TAH_NIC;
		end;
//		write('ok6');
	    end;
	    { ideme do strely? }
	    if tahh=TP_TAH_DOPREDU then begin
		for i:=1 to 3 do if stre[STAV_POLOMER+1-xdopredu[ja.dir,i],STAV_POLOMER+1+ydopredu[ja.dir,i]]<>0 then begin
		    { pred nami je strela }
		    tahh:=TP_TAH_NIC;
		    break;
		end;
	    end;
//	    writer(10,'i');
	    { mozme zostrelit strelu? }
	    if nastrelu<>0 then with objekty[nastrelu].strela do begin
		if abs(ja.dir-dir-4+16) mod 8=0 then strelit:=true
		else if vlavo then tahh:=TP_TAH_DOLAVA
		else tahh:=TP_TAH_DOPRAVA; 
	    end;
//	    writer(11,'j');
    end;(**)
//    writer(12,' 12the end');
    with stav do if tahh=TP_TAH_DOPREDU then for i:=1 to 3 do begin
	if (vidim[-xdopredu[ja.dir,i]+STAV_POLOMER+1,STAV_POLOMER+1+ydopredu[ja.dir,i]]<>char(ja.number+ord('a')-1)) and
	    (vidim[-xdopredu[ja.dir,i]+STAV_POLOMER+1,STAV_POLOMER+1+ydopredu[ja.dir,i]]>='a') and 
	    (vidim[-xdopredu[ja.dir,i]+STAV_POLOMER+1,STAV_POLOMER+1+ydopredu[ja.dir,i]]<='e') then
	    tahh:=TP_TAH_DOLAVA;
    end;

  { koniec nasho kodu }
end; 

{
procedure handleKeyboard;
var k:TKeyEvent;

begin
  while PollKeyEvent<>0 do begin
    k:=getKeyEvent;
    k:=translateKeyEvent(k);

    case k of
      33619745 : tah:= TP_TAH_DOPREDU;
      33619751 : tah:= TP_TAH_DOZADU;
      33619747 : tah:= TP_TAH_DOLAVA;
      33619749 : tah:= TP_TAH_DOPRAVA;

      14624    : strielat:= true;   //space

      4209,     //q,Q
      4177     : halt;
    end;
  end;
end;

}
function vratTah:integer;
begin
{  handleKeyboard;
  vratTah:=tah;
  tah:=TP_TAH_NIC;
  tah:=TP_TAH_NIC;
//  tah:=TP_TAH_DOPREDU;  //ak sa chces ist dopredu bez stlacania sipky hore}
  vratTah:=tahh;
  if (tahh=TP_TAH_DOPREDU) and ((kamx<>0) or (kamy<>0)) then begin
//    write('ok7');
	inc(kamx,ysmer[mydir]);
	dec(kamy,xsmer[mydir]);
//    write('ok8');
  end;
end;

function mamStrelit:boolean;
begin
//  handleKeyboard; { toto potom dat prec }
  { nas kod }
  mamStrelit:=strelit;
  strelit:=false;
  { koniec nasho kodu }
end;

function vratHlasku:string;
begin
	vratHlasku:='';
end;

end.
