unit player;
interface
uses types;

function otocna(dir: integer): integer;
procedure init;
procedure done;
procedure novyStav( const stav:TStav);
function vratTah: integer;
function mamStrelit: boolean;
procedure vypis;
//hlaska nesmie obsahovat obsahovat znaky noveho riadku
function vratHlasku:string;

implementation
uses  linux, sysutils,
     config;

    type TnasTyp=record c: char; en: integer;home : array[1..6]of integer; end;
var lastNow : TDateTime;
    lastattack, following,tah,lasttah,ideme,otoc,domovE,rovno,smer,smer2,lsmer2,lastdir,cakam : integer;
    lastpos: TPoint;
    tank,strielat,vracam,iq2 : boolean;
    s : TStav;
    map: array[-MAX_BOARD_SIZE..MAX_BOARD_SIZE,-MAX_BOARD_SIZE..MAX_BOARD_SIZE] of TnasTyp;
    last: TnasTyp;

function now_msec:double;
var hour, min, sec, msec : word;
begin
  getTime(hour, min, sec, msec);
  now_msec:= date + (hour*60*60 + min*60 + sec + msec/100.0)/(24*60*60);
end;
{
procedure textOut(x,y:word; const s:string);  //z dokumentacie
var p,m,i: word;
begin
  p:=(x-1)+(y-1)*screenwidth;
  m:=length(s);
  if m+x>=screenwidth then
    m:=screenwidth-x;
  for i:=1 to m do
    videobuf^[p+i-1]:=ord(s[i])+($07 shr 8);
end;
}
procedure init;
var i,j,q: integer;
begin
	tank:=false;
  cakam:=0;
  following:=0;
  fillchar(last,sizeof(last),0);
  vracam:=false;
//  InitVideo;
//  InitKeyboard;
  iq2:=false; 
  rovno:=0;
  lastNow:=now_msec;
  randomize;
  smer:=random(8);
  smer2:=smer;
  tah:=TP_TAH_NIC;
  strielat:=false;
  fillchar(map, sizeof(map),0);
	for i:=-MAX_BOARD_SIZE to MAX_BOARD_SIZE do 
		for j:=-MAX_BOARD_SIZE to MAX_BOARD_SIZE do begin 
			map[j,i].en:=maxint;
			for q:=1 to 6 do
				map[i,j].home[q]:=-1;
		end;
	map[0,0].en:=0;
	for q:=1 to 6 do last.home[q]:=-1;
end;

procedure done;
begin
//  DoneVideo;
//  DoneKeyboard;
end;

procedure updateMap(stav: TStav); forward;

procedure novyStav( const stav:TStav);
var pis_y, i, j : integer;
begin
{  with stav do begin
    SetCursorPos( 1,0 );
    writeln(' Cas ',cas:4);

    for i:=1 to STAV_STRANA do begin
      for j:=1 to STAV_STRANA do
        write(vidim[i][j]);
      writeln;
    end;

    pis_y:=1;
    for i:=1 to objekty_pocet do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      case objekty[i].typ of
        objTank   :
          with objekty[i].tank do begin
            writeln('Hrac ',number,':  poz ',poz.x:3,',',poz.y:3,'  smer ',dir,'  spi ',spi,'       ');
            SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
            writeln('         EN ',en:4,'  HP ',hp:4,'  striel ', striel,'          ');
          end;
        objStrela :
          with objekty[i].strela do
            writeln('Strela : pos ',poz.x:3,',',poz.y:3, '  smer ',dir,'  vlastnik ',number,'           ');
        objDom :
          with objekty[i].dom do
            writeln('Dom ',number,': pos ',poz.x:3,',',poz.y:3, '  vlastnik ',number,'           ');
        else
          writeln('Neosetreny objekt                                        ');
      end;
    end;
    for i:=objekty_pocet to STAV_STRANA+1 do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      writeln('                                              ');
    end;

  SetCursorPos( 1, STAV_STRANA+1);
  with ja do 
    writeln('EN ',en:4,'  HP ',hp:4, '  spi ',spi:2, '  striel ',striel:2, '                   ');
  writeln(' domov ',domov.x:3,', ',domov.y:3, '                          ');
 
  end;

  while (now_msec<=(lastNow+0.05/(24*60*60))) do
    delay(10);
  lastNow:=now_msec;}
  s:=stav;
  updateMap(s);
end; 

function iq: boolean;
var i: integer;
begin
	for i:=1 to s.objekty_pocet do begin
		if ((s.objekty[i].typ=objTank)or(s.objekty[i].typ=objStrela))and(s.objekty[i].tank.number<>s.ja.number) then begin
			iq2:=true;
		end;
	end;
	iq:=iq2;
//	SetCursorPos(2,24);write('iq: ',iq2);
end;

procedure updateMap(stav: TStav);
var i,j: integer;
	tmp: char;
begin
	for i:=1 to STAV_STRANA do 
		for j:=1 to STAV_STRANA do begin
			tmp:=stav.vidim[j,i];	
			
			map[stav.domov.x-STAV_POLOMER+j-1,stav.domov.y-STAV_POLOMER+i-1].c:=tmp;
		end;	
end;

procedure vypis;
var i,j: integer;
begin
	for i:=-MAX_BOARD_SIZE to MAX_BOARD_SIZE do begin
		for j:=-MAX_BOARD_SIZE to MAX_BOARD_SIZE do write(stderr,map[j,i].c);
		writeln(stderr);
	end;
end;
{
procedure handleKeyboard;
var k:TKeyEvent;

begin
  while PollKeyEvent<>0 do begin
    k:=getKeyEvent;
    k:=translateKeyEvent(k);

    case k of
      33619745 : tah:= TP_TAH_DOPREDU;
      33619751 : tah:= TP_TAH_DOZADU;
      33619747 : tah:= TP_TAH_DOLAVA;
      33619749 : tah:= TP_TAH_DOPRAVA;

      14624    : strielat:= true;   //space

      4209,     //q,Q
      4177     : halt;
      9064	: vracam:=not vracam;
    end;    
  end;
end;
}
function minE(var stav: TStav): integer;
var tmp,tmp2:real;
begin	
	if abs(stav.domov.x)>abs(stav.domov.y) then tmp2:=stav.domov.y else
	tmp2:=stav.domov.x;
	tmp:=abs(stav.domov.x)+abs(stav.domov.y)-abs(tmp2);
	minE:=trunc(tmp*3*TANK_EN_BAGER);
end;

function navrat(var stav: TStav): boolean;
begin
	domovE:=minE(stav);
	if domovE>map[stav.domov.x,stav.domov.y].en+800 then 
		domovE:=map[stav.domov.x,stav.domov.y].en+800;
	navrat:=(stav.ja.en <= domovE*1.5)or vracam;
	if (stav.domov.x=0) and (stav.domov.y=0) 
	and (stav.ja.en=4000) and (stav.ja.hp>5000)
	then vracam:=false;
	if ideme=0 then ideme:=1;
end;

function kdeJeDomov: integer;
var presnost,i: integer;
begin
	
	if minE(s)<map[s.domov.x,s.domov.y].en+800 then begin 
	presnost:=0;
	if s.domov.x>presnost then begin
	    if s.domov.y>presnost then begin
		i:=7;
	    end else if s.domov.y<presnost then begin
		    	i:=5;
	    end else begin
	    	i:=6;
	    end;
	end else if s.domov.x<presnost then begin
	    if s.domov.y>presnost then begin
	    	i:=1;
	    end else if s.domov.y<presnost then begin
	    	i:=3;
	    end else begin
	    	i:=2;
	    end;
	end else begin
	    if s.domov.y>presnost then begin
	    	i:=0;
	    end else if s.domov.y<presnost then begin
	    	i:=4;
	    end else begin
	    	i:=-1;
	    end;
	end;
  end else begin i:=map[s.domov.x,s.domov.y].home[1];end;
  kdeJeDomov:=i;
end;

function hd(smr: integer): integer;
begin
	case smr of
	0: hd:=-1;
	1: hd:=-1;
	2: hd:=0;
	3: hd:=1;
	4: hd:=1;
	5: hd:=1;
	6: hd:=0;
	7: hd:=-1;
	end;
end;

function dd(smr: integer): integer;
begin
	case smr of
	0: dd:=0;
	1: dd:=1;
	2: dd:=1;
	3: dd:=1;
	4: dd:=0;
	5: dd:=-1;
	6: dd:=-1;
	7: dd:=-1;
	end;
end;

function pohyb: integer;
{var c,ok1,ok2: char ;}
	
begin
	inc(rovno);
	{ok1:=chr(s.ja.number+96);} {pismeno}
	{ok2:=chr(s.ja.number+48);} {cislo}
	{c:=map[s.domov.x+3*horedole,s.domov.y+3*dopravadolava].c;
	if (c<>'#')or(c='') then }
	if (lastpos.x=s.domov.x)and(lastpos.y=s.domov.y)and(lastdir=s.ja.dir) then begin
		smer:=(random(3)+3+smer) mod 8;
		smer2:=smer;
	end;
	if random(50-rovno)=0 then begin
		lsmer2:=smer2;
		while (smer2=lsmer2) do begin
			smer2:=(random(3)+smer-1) mod 8;
		end;
		rovno:=0;
	end;
		lastpos:=s.domov;
		lastdir:=s.ja.dir;
		pohyb:=otocna(smer2);
//	SetCursorPos(1,24);
//	write(smer,' ',smer2);
end;

function kolko(i: integer): integer;
begin
	i:=i mod 8;
	case i of
	0: kolko:=0;
	1: kolko:=1;
	2: kolko:=2;
	3: kolko:=3;
	4: kolko:=4;
	5: kolko:=3;
	6: kolko:=2;
	7: kolko:=1;
	end;
end;

function otocna(dir: integer): integer;
var i,tmp2: integer;
begin
		if s.ja.dir=dir then begin otocna:=TP_TAH_DOPREDU 
		end else begin
			for i:=0 to 7 do begin
				if (s.ja.dir+i) mod 8=dir then tmp2:=i;
			end;
			i:=tmp2;
			if i<=4 then begin 
				otocna:=TP_TAH_DOPRAVA;
			end;
			if i>4 then begin 
				otocna:=TP_TAH_DOLAVA;
			end;
		end;
end;

function follow(i: integer): integer;
var dir: integer;
begin
	dir:=map[s.domov.x,s.domov.y].home[i];
	if dir=-2 then begin 
		follow:=TP_TAH_NIC;
		following:=0;
//		SetCursorPos(1,23);write('X');
	end else
	follow:=otocna(dir);
//	SetCursorPos(2,23);write('following ',i,' ',dir);
	
end;

procedure sethouse(n,x,y: integer);
var i,j,k: integer;
begin
	map[s.domov.x+x,s.domov.y+y].home[n]:=-2;
	if (x<>0) and (y<>0) then if x>=0 then begin 
		for i:=0 to x-1 do map[s.domov.x+i,s.domov.y+y].home[n]:=2;
	end else begin
		for i:=x+1 to 0 do map[s.domov.x+i,s.domov.y+y].home[n]:=6;
	end;
	if y>=0 then begin
		for i:=0 to y-1 do map[s.domov.x+x,s.domov.y+i].home[n]:=4;
	end else begin
		for i:=y+1 to 0 do map[s.domov.x+x,s.domov.y+i].home[n]:=0;
	end;
	j:=s.domov.x;
	i:=s.domov.y;
	while (i<>0)and(j<>0) do begin
		k:=map[j,i].home[1];
		j:=j+dd(k);
		i:=i+hd(k);
		map[j,i].home[n]:=(k+4) mod 8;
	end;
	writeln(stderr,'seting house');
end;

function zameraj(co: TPoint): integer;
var presnost: integer;
	x,y,i: integer;
begin
	x:=co.x;
	y:=co.y;
	presnost:=1;
	if x>presnost then begin
	    if y>presnost then begin
		i:=7;
	    end else if y<presnost then begin
		    	i:=5;
	    end else begin
	    	i:=6;
	    end;
	end else if x<presnost then begin
	    if y>presnost then begin
	    	i:=1;
	    end else if y<presnost then begin
	    	i:=3;
	    end else begin
	    	i:=2;
	    end;
	end else begin
	    if y>presnost then begin
	    	i:=0;
	    end else if y<presnost then begin
	    	i:=4;
	    end else begin
	    	i:=-1;
	    end;
	end;
	zameraj:=i;
end;

function attack: integer;
var dir,live,i: integer;
begin
	dir:=30000;
	live:=30000;
	for i:=1 to s.objekty_pocet do begin
		if (s.objekty[i].typ=objTank)and(s.objekty[i].tank.number<>s.ja.number) then begin
			if live>(s.objekty[i].tank.hp+s.objekty[i].tank.en) then begin
				live:=s.objekty[i].tank.hp+s.objekty[i].tank.en;
				dir:=zameraj(s.objekty[i].tank.poz);
			end;
		end;
		if (s.objekty[i].typ=objStrela)and(s.objekty[i].strela.number<>s.ja.number)and(dir=30000) then begin 
			dir:=s.objekty[i].strela.dir;
			live:=20000;
		end;
	
	end;
	 if dir<>30000 then begin
		if (otocna((dir+4) mod 8)=TP_TAH_DOPREDU)and(live<>20000) then 
			strielat:=true else strielat:=false;
			attack:=otocna((dir+4)mod 8);
			lastattack:=dir;
		if live<>20000 then tank:=true else tank:=false;	
	end else begin 
		{iq2:=false;}
		attack:=otocna((lastattack+4)mod 8);
		inc(cakam);
		if cakam>10 then begin
			cakam:=0;
			iq2:=false;
		end;
	end;
end;

function vratTah:integer;
var dir,q: integer;
begin
	
	if (s.domov.x=0)and(s.domov.y=0) then begin {ak sme doma, tak resetujme last}
  		{fillchar(last,sizeof(last),0);
		for q:=1 to 6 do last.home[q]:=map[0,0].home[q];}
		ideme:=0;
  	end;
  
	{update tabulky map}
	if lasttah=TP_TAH_DOPREDU then begin 
		if last.en+6+kolko(abs(otoc))*4 < map[s.domov.x,s.domov.y].en then begin
			map[s.domov.x,s.domov.y].en:=last.en+6+kolko(abs(otoc))*4;
			map[s.domov.x,s.domov.y].home[1]:=(s.ja.dir+4) mod 8;
		end;
			for q:=2 to 6 do 
			if (map[s.domov.x,s.domov.y].home[q]=-1)and(last.home[q]<>-1) then 
			map[s.domov.x,s.domov.y].home[q]:=(s.ja.dir+4) mod 8;
			
		last:=map[s.domov.x,s.domov.y];			
		otoc:=0;
	end else if lasttah=TP_TAH_DOPRAVA then begin
		inc(otoc);
	end else if lasttah=TP_TAH_DOLAVA then begin
		dec(otoc);
	end;
	{koniec update map}
	
//  handleKeyboard;
 
if iq and tank then 
  	tah:=attack
else if following>0 then tah:=follow(following)
else if navrat(s) then begin
	if ideme=1 then begin
		sethouse(6,0,0);following:=0;
		ideme:=2;
	end;
	vracam:=true;
	if (s.domov.x=0) and (s.domov.y=0) 
	and (s.ja.en=4000) and (s.ja.hp>5000)
	then vracam:=false;
	dir:=kdeJeDomov;
	if dir=-1 then tah:=TP_TAH_NIC else tah:=otocna(dir);
  end else if iq and (tank or true) then tah:=attack else tah:=pohyb;
  {else 
  if following>0 then tah:=follow(following) 
  else if not iq then begin
		tah:=pohyb;
	end else tah:=attack;}

	lasttah:=tah;
	vratTah:=tah;
	tah:=TP_TAH_NIC;
	
//  tah:=TP_TAH_DOPREDU;  //ak sa chces ist dopredu bez stlacania sipky hore
{tu bolo end}
//	SetCursorPos(1,24);
//	write('                                                            ');
//	SetCursorPos(1,24);
	write('c ',map[s.domov.x,s.domov.y].home[6],' x');
	
end;

function mamStrelit:boolean;
begin
//  handleKeyboard;
  //strielat:=fire(s);
  mamStrelit:=strielat;
  strielat:=false;
end;

function vratHlasku:string;
begin
	vratHlasku:='';
end;

end.
