#ifndef		_HAVE_TYPES_H
#define		_HAVE_TYPES_H

#include	"../com/config.h"


#define		MAX_OBJEKTOV	80



struct TPoint
{
  int x, y;
};


struct TTank
{
  int id;			/* ID */
  struct TPoint poz;		/* Relativna poloha k nam */
  int dir;			/* Smer natocenia */
  int number;			/* Cislo hraca */
  int en;			/* Energia */
  int hp;			/* Hit points */
  int spi;			/* Ako dlho bude spat */
  int striel;			/* Kolko striel moze vystrelit */
};


struct TStrela
{
  int id;			/* ID */
  struct TPoint poz;		/* Relativna poloha k nam */
  int dir;			/* Smer natocenia */
  int number;			/* Cislo hraca */
};


struct TDom
{
  int id;			/* ID */
  struct TPoint poz;		/* Relativna poloha k nam */
  int number;			/* Cislo hraca */
};


struct TObjekt
{
  TypyObjektov typ;		/* Typ objektu */
  union
  {
    struct TTank objTank;
    struct TStrela objStrela;
    struct TDom objDom;
  } obj;
};


struct TStav
{
  int cas;					/* Ako dlho este pobezi hra */
  int hracov;					/* Pocet hracov */
  struct TPoint domov;				/* Relativna poloha k domu */
  struct TTank ja;				/* Ja */
  char vidim[STAV_STRANA][STAV_STRANA];		/* Cast mapy, ktoru vidim */
  int objekty_pocet;				/* Pocet objektov */
  struct TObjekt objekty[MAX_OBJEKTOV];		/* Objekty, ktore vidim */
};


extern int player_number;

#endif	/* _HAVE_TYPES_H */
