unit types;
interface
uses config;

const MAX_OBJEKTOV = 80;
      STAV_STRANA  = STAV_POLOMER*2+1;
      
type
  TPoint = record
    x,y:integer;
  end;
  TTank = record 
    id : integer;   //jednoznacny identifikator objektu
    poz : TPoint;   //relativna pozicia od nasej pozicie
    dir, number,   //smer natocenia, cislo hraca
    en, hp,        //energia, hitpointy
    spi, striel: integer;  //kolko cas. jednotiek bude necinny, kolko striel moze vystrelit
  end;
  
  TStrela = record 
    id : integer;   //jednoznacny identifikator objektu
    poz : TPoint;   //relativna pozicia od nasej pozicie
    dir, number  : integer;
  end;
  
  TDom = record 
    id : integer;   //jednoznacny identifikator objektu
    poz : TPoint;   //relativna pozicia od nasej pozicie
    number  : integer;
  end;
  
  TObjekt = record
    typ : TypyObjektov;
    case TypyObjektov of 
    objTank   : ( tank   : TTank);
    objStrela : ( strela : TStrela);
    objDom    : ( dom    : TDom);
  end;

  TStav = record
    cas   : integer;   //kolko casovych jednotiek uz bezi hra
    hracov: integer;   //kolko je vsetkych hracov
    domov : TPoint;    //rozdiel suradnic oproti domu
    ja    : TTank;     //informacie o men
    vidim : array [1..STAV_STRANA, 1..STAV_STRANA] of char;  //cast mapy, ktoru vidim
    objekty_pocet : integer;                                             
    objekty : array [1..MAX_OBJEKTOV] of TObjekt;            //objekty, ktore vidim na mape
  end;


implementation

end.
