unit player;
interface
uses types;

{DEFINE output}
procedure init;
procedure done;
procedure novyStav( const nstav:TStav);
function vratTah:integer;
function mamStrelit:boolean;

//hlaska nesmie obsahovat obsahovat znaky noveho riadku
function vratHlasku:string;

implementation
uses linux, sysutils,
     config;

const max=MAX_BOARD_SIZE;
      ss=STAV_STRANA;
      qsize=200;

var lastNow : TDateTime;
    tah : integer;
    strielat : boolean;

//    mapa : array[-max..max,-max..max] of char;
    stav : TStav;
    px,py,z : integer; 
    v,qx,qy : array[0..qsize-1] of integer;
    mode : integer;
    modex,modey,modetime:integer;
    oldx,oldy,oldwait,oldenergy,oldenergywait:integer;
    neprx,nepry:integer;
    danger:array[1..5] of integer;
    gox,goy,gotime:integer;
    minx,maxx,miny,maxy:integer;


function xq:integer;
begin xq:=qx[z]; end;
function yq:integer;
begin yq:=qy[z]; end;

function vzd(a,b : integer):longint;
 var v:longint;
begin
 v:=abs(qx[a]-qx[b])+abs(qy[a]-qy[b]);
 if abs(a-b)>1 then v:=v*7;
 vzd:=v;
end;
  
procedure qpush(x,y : integer);
begin
 inc(z);
 qx[z]:=x;
 qy[z]:=y;
end;

procedure qpop;
begin
 if (z>1) then dec(z);
end;





function now_msec:double;
var hour, min, sec, msec : word;
begin
  getTime(hour, min, sec, msec);
  now_msec:= date + (hour*60*60 + min*60 + sec + msec/100.0)/(24*60*60);
end;
{
procedure textOut(x,y:word; const s:string);  //z dokumentacie
var p,m,i: word;
begin
  p:=(x-1)+(y-1)*screenwidth;
  m:=length(s);
  if m+x>=screenwidth then
    m:=screenwidth-x;
  for i:=1 to m do
    videobuf^[p+i-1]:=ord(s[i])+($07 shr 8);
end;
}
procedure init;
 var i,j : integer;
begin
modetime:=0;
mode:=1;
oldwait:=5;
gox:=random(300)-150;
goy:=random(300)-150;
gotime:=random(40);
minx:=-150;
miny:=-150;
maxx:=150;
maxy:=150;
//  InitVideo;
  //InitKeyboard;

  lastNow:=now_msec;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\//\/\/\/\/\/\/\/\/\}

{  tah:=TP_TAH_NIC;
  strielat:=false;
  for i:=-max to max do
   for j:=-max to max do
    mapa[i,j]:='?';
  for i:=1 to ss do
   for j:=1 to ss do
    stav.vidim[i,j]:='?';
    
    for z:=1 to 5 do danger[z]:=1;}

 z:=0;
 qpush(0,0);

 mode:=1; 
 
 
 randomize;
end;

procedure done;
begin
//  DoneVideo;
//  DoneKeyboard;
end;

procedure novyStav( const nstav:TStav);
var pis_y, i, j : integer;
begin
 stav:=nstav;
 
{ for i:=1 to ss do
  for j:=1 to ss do
   mapa[i-(ss div 2)-1+stav.domov.y,j-(ss div 2)-1+stav.domov.x]:=stav.vidim[i,j];}
 px:=stav.domov.x;
 py:=stav.domov.y;    

{VYKRESLUJE /\/\/\/\/\//\/\/\/\/\/\/\/\//\/\}
{$IFDEF output}
  with stav do begin
   SetCursorPos( 1,0 );
    writeln(' Cas ',cas:4); 

    for i:=1 to STAV_STRANA do begin
      for j:=1 to STAV_STRANA do
       begin
        case vidim[i][j] of
	'x':textcolor(8);
	'2':textcolor(15);
	'b':textcolor(14);
	else textcolor(7);
	end;
        write(vidim[i][j]);
       end;	
      writeln;
    end;

    pis_y:=1;
    for i:=1 to objekty_pocet do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      case objekty[i].typ of
        objTank   :
          with objekty[i].tank do begin
            writeln('Hrac ',number,':  poz ',poz.x:3,',',poz.y:3,'  smer ',dir,'  spi ',spi,'       ');
            SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
            writeln('         EN ',en:4,'  HP ',hp:4,'  striel ', striel,'          ');
          end;
        objStrela :
          with objekty[i].strela do
            writeln('Strela : pos ',poz.x:3,',',poz.y:3, '  smer ',dir,'  vlastnik ',number,'           ');
        objDom :
          with objekty[i].dom do
            writeln('Dom ',number,': pos ',poz.x:3,',',poz.y:3, '  vlastnik ',number,'           ');
        else
          writeln('Neosetreny objekt                                        ');
      end;
    end;
    for i:=objekty_pocet to STAV_STRANA+1 do begin
      SetCursorPos( STAV_STRANA+2, pis_y); inc(pis_y);
      writeln('                                              ');
    end;

  SetCursorPos( 1, STAV_STRANA+1);
  with ja do 
    writeln('EN ',en:4,'  HP ',hp:4, '  spi ',spi:2, '  striel ',striel:2, '                   ');
  writeln(' domov ',domov.x:3,', ',domov.y:3, '                          ');
 
  end;
{$ENDIF}

//  while (now_msec<=(lastNow+0.05/(24*60*60))) do
//    delay(100);
 // lastNow:=now_msec;
end; 

{
procedure handleKeyboard;
var k:TKeyEvent;

begin
  while PollKeyEvent<>0 do begin
    k:=getKeyEvent;
    k:=translateKeyEvent(k);

    case k of
      33619745 : tah:= TP_TAH_DOPREDU;
      33619751 : tah:= TP_TAH_DOZADU;
      33619747 : tah:= TP_TAH_DOLAVA;
      33619749 : tah:= TP_TAH_DOPRAVA;

      14624    : strielat:= true;   //space

      4209,     //q,Q
      4177     : halt;
    end;
  end;
end;


}









function chod(x,y : integer):integer;
 var vx,vy : integer;
begin
 vx:=px-x;
 vy:=y-py;
 {$IFDEF output}
 setcursorpos(50,22);
 writeln(vx,'   ',vy,'   ',px,'   ',py);
 {$ENDIF}
    if (vx<0) then
      begin
       if (vy<0) then
          begin
	    case stav.ja.dir of
	    1:chod:=TP_TAH_DOPREDU;
	    2,3,4,5:chod:=TP_TAH_DOLAVA;
	    6,7,0:chod:=TP_TAH_DOPRAVA;
	    end;
	  end
	  else
	if (vy=0) then
    	  begin
	    case stav.ja.dir of
	    2:chod:=TP_TAH_DOPREDU;
	    3,4,5:chod:=TP_TAH_DOLAVA;
	    6,7,0,1:chod:=TP_TAH_DOPRAVA;
	    end;
	  end
	  else
    	  begin
	    case stav.ja.dir of
	    3:chod:=TP_TAH_DOPREDU;
	    0,1,2:chod:=TP_TAH_DOPRAVA;
	    4,5,6,7:chod:=TP_TAH_DOLAVA;
	    end;
	  end;
           end else
    if (vx=0) then
      begin
       if (vy<0) then
          begin
	    case stav.ja.dir of
	    0:chod:=TP_TAH_DOPREDU;
	    1,2,3,4:chod:=TP_TAH_DOLAVA;
	    5,6,7:chod:=TP_TAH_DOPRAVA;
	    end;
	  end
	  else
	if (vy=0) then
    	  begin
	   chod:=TP_TAH_NIC;
	   
	  end
	  else
    	  begin
	  
	    case stav.ja.dir of
	    4:chod:=TP_TAH_DOPREDU;
	    1,2,3: chod:=TP_TAH_DOPRAVA; 
	    5,6,7,0: chod:=TP_TAH_DOLAVA; 
	    end;
	    
	  end;
      
      end
      else
       begin
    	if (vy<0) then
          begin
	    case stav.ja.dir of
	    7:chod:=TP_TAH_DOPREDU;
	    0,1,2,3:chod:=TP_TAH_DOLAVA;
	    4,5,6:chod:=TP_TAH_DOPRAVA;
	    end;
	  end
	  else
	if (vy=0) then
    	  begin
	    case stav.ja.dir of
	    6:chod:=TP_TAH_DOPREDU;
	    7,0,1,2:chod:=TP_TAH_DOLAVA;
	    3,4,5:chod:=TP_TAH_DOPRAVA;
	    end;

	  end
	  else
    	  begin
	    case stav.ja.dir of
	    5:chod:=TP_TAH_DOPREDU;
	    6,7,0,1:chod:=TP_TAH_DOLAVA;
	    2,3,4:chod:=TP_TAH_DOPRAVA;
	    end;
       end;
      end;

end;


function trafi(a,b:integer):boolean;
begin
trafi:=false;
if ((abs(px-a)<3) or (abs(py-b)<3) or (abs(abs(px-a)-abs(py-b))<4)) then trafi:=true;
trafi:=true;
end;


function je_stena:boolean;
var q,w:integer;
begin
je_stena:=false;
for q:=1 to 19 do
 for w:=1 to 19 do if stav.vidim[q,w]='X' then
     begin
     
      je_stena:=true;
       if (q<5) and (abs(10-w)<3)  then begin minx:=q-10; gox:=gox+10; end;
       if (q>10) and (abs(10-w)<3) then begin  maxx:=q+10; gox:=gox-10; end;
       if (w<9)  and (abs(10-q)<3) then begin  miny:=w-10; goy:=goy+10; end;
       if (w>10) and (abs(10-q)<3) then begin  maxy:=w+10; goy:=goy-10; end;
       
      end;

end;

function vrattah:integer;
 var ttah : integer;
     q:    integer;
begin
//  handleKeyboard;
{   chod:=tah;
     tah:=TP_TAH_NIC;
  tah:=TP_TAH_NIC;}
{\//\/\/\/\/\\\\\/\//\/\/\/\/\/\/}
if (stav.ja.hp<9000) and (mode<>2) then mode:=3;

if modetime>0 then dec(modetime) else mode:=1;
for q:=1
 to stav.objekty_pocet do
   case (stav.objekty[q].typ) of
   objtank:if (stav.objekty[q].tank.id<>stav.ja.id) then 
      begin
       mode:=2;
       modetime:=70;
       modex:=px+stav.objekty[q].tank.poz.x;
       modey:=py+stav.objekty[q].tank.poz.y;
       oldenergy:=stav.objekty[q].tank.hp;
        modetime:=6;

{       if danger[stav.objekty[q].tank.id] < -50 then
         begin
	
         modex:=3;//-px+stav.objekty[q].tank.poz.x;
         modey:=3;//-py+stav.objekty[q].tank.poz.y;
	 end;}
         
      end; 
  objstrela:if (stav.objekty[q].strela.number<>stav.ja.id) then
      begin if (mode<>2) then 
          begin
	   
           mode:=2;
           case stav.objekty[q].strela.dir of
            0:begin modex:=px;    modey:=py+20;    end;
            1:begin modex:=px-20; modey:=py+20; end;
            2:begin modex:=px-20; modey:=py; end;
            3:begin modex:=px-20; modey:=py-20; end;
            4:begin modex:=px;    modey:=py-20; end;
            5:begin modex:=px+20; modey:=py-20; end;
            6:begin modex:=px+20; modey:=py;    end;
            7:begin modex:=px+20; modey:=py+20; end;
           end;
	    modetime:=6;

          end
	  else
	  begin
//          if (danger[stav.objekty[q].strela.number])>-100 then  dec(danger[stav.objekty[q].strela.number]);
	  end;
    end;	         
   end;

  if stav.ja.en<1300 then
    begin mode:=3; modetime:=5; neprx:=modex; nepry:=modey; end;

 case mode of
 1 :  begin
     dec(gotime);
     if (gotime<0) or ((je_stena) AND (random(10)>7)) then begin gox:=random(-minx+maxx)+minx; goy:=random(-miny+maxy)+miny; gotime:=random(30); end;
{       if random(5)>0 then ttah:=tp_tah_dopredu else
        if random(10)>7 then ttah:=TP_TAH_DOPRAVA; 
       if (ttah=TP_TAH_DOLAVA) or (ttah=TP_TAH_DOprava) then qpush(px,py);}
       ttah:=chod(gox,goy);
      end; 
   2: begin
        
	ttah:=chod(modex,modey);
        if (ttah=TP_TAH_NIC) and (random(30)>25) then ttah:=TP_TAH_DOZADU;
//	if (abs(px-modex)+abs(py-modey)<6) then ttah:=TP_TAH_NIC;
      end;  
   3: begin      
       ttah:=chod(0,0); 
//       if ttah=TP_TAH_NIC then qpop;
       if (stav.ja.en<3500) or (stav.ja.hp<9000) then modetime:=5;
      end;

 end;

if ((oldx=px) and (oldy=py)) then 
  if (oldwait<0) then 
   begin
     ttah:=TP_TAH_DOZADU; oldwait:=10;
//          if random(10)>5 then ttah:=TP_TAH_DOPRAVA;
//          if random(10)>5 then ttah:=TP_TAH_DOLAVA;
          if random(10)>7 then ttah:=TP_TAH_DOPREDU;
      gox:=random(-minx+maxx)+minx; goy:=random(-miny+maxy)+miny; gotime:=random(30); 
      mode:=1;
      end 
      else dec(oldwait);
   
  vrattah:=ttah;
oldx:=px;
oldy:=py;
{$IFDEF output}
writeln('Wait :',oldwait ,'MOde time : ',modetime, 'danger ',danger[1]); 
{$ENDIF}
//  tah:=TP_TAH_DOPREDU;  //ak sa chces ist dopredu bez stlacania sipky hore
end;

function mamStrelit:boolean;
 var i:integer;
begin
//  handleKeyboard;
{  mamStrelit:=strielat;
  strielat:=false;}
{/\/\/\/\//\/\/\/\/\/\/\/\/\/\/\/\/\/\/}  


  mamStrelit:=false;
  if mode=2 then mamstrelit:=trafi(modex,modey);
  if stav.cas<150 then mamstrelit:=true;

end;




function vratHlasku:string;
begin
  vrathlasku:='';
{  if random(100)>95 then
  if mode=2 then 
    begin
 case random(5) of
  0 : vrathlasku:='kubus: "FeRko je hlubik!!"';
  1 : vrathlasku:='gottwik: "gottwik je macher!!"';  
  2 : vrathlasku:='gottwik: "Kubus ale toto tak vyhrame jak psi, vsak toto je nas dabel."';  
  3 : vrathlasku:='ferko: "Ty Tubus! utekaj ... utekaj a neobracaj sa!"';  
  4 : vrathlasku:='#*&^:>];.#:];@/:>; .. ferko zase robis blbosti!!';    
  5 : vrathlasku:='ides: "WSX je player 2 !"'
  6 : vrathlasku:='to engine: "skill -KILL other"'
  end;
   end
   else
   if mode=3 then
    begin
    case random(4) of
    0:vrathlasku:='recharge batteries';
    1:vrathlasku:='';
    end;
    end;}
end;

end.



